Lattice Grid Buy a licence

demo D208

Configuring a type

One field, five presentations; the stored value never changes

createUnitType({ display, decimals, … })

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid, createUnitType } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

// The same field stored in metres, shown four ways. The stored value never
// changes; only the display does.
const dataTypes = {
  spanAuto: createUnitType({ system: 'length', unit: 'm', display: 'auto' }),
  spanMm:   createUnitType({ system: 'length', unit: 'm', display: 'mm' }),
  spanKm:   createUnitType({ system: 'length', unit: 'm', display: 'km', decimals: 3 }),
  spanSig:  createUnitType({ system: 'length', unit: 'm', display: 'auto', significantFigures: 3 }),
};

const columns = [
  { field: 'run', title: 'Run', layout: { pin: 'start', width: 120 } },
  { field: 'span', id: 'stored', title: 'Stored (m)', type: 'number' },
  { field: 'span', id: 'auto', title: "display: 'auto'", type: 'spanAuto' },
  { field: 'span', id: 'mm', title: "display: 'mm'", type: 'spanMm' },
  { field: 'span', id: 'km', title: "display: 'km'", type: 'spanKm' },
  { field: 'span', id: 'sig', title: '3 sig figs', type: 'spanSig' },
];

const rows = [/* runs, each with a span in metres */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:460px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    dataTypes: dataTypes,
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Lattice Grid Buy a licence

demo D208

Configuring a type

One field, five presentations; the stored value never changes

createUnitType({ display, decimals, … })

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid, createUnitType } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  // The same field stored in metres, shown four ways. The stored value never
  // changes; only the display does.
  const dataTypes = {
    spanAuto: createUnitType({ system: 'length', unit: 'm', display: 'auto' }),
    spanMm:   createUnitType({ system: 'length', unit: 'm', display: 'mm' }),
    spanKm:   createUnitType({ system: 'length', unit: 'm', display: 'km', decimals: 3 }),
    spanSig:  createUnitType({ system: 'length', unit: 'm', display: 'auto', significantFigures: 3 }),
  };

  const columns = [
    { field: 'run', title: 'Run', layout: { pin: 'start', width: 120 } },
    { field: 'span', id: 'stored', title: 'Stored (m)', type: 'number' },
    { field: 'span', id: 'auto', title: "display: 'auto'", type: 'spanAuto' },
    { field: 'span', id: 'mm', title: "display: 'mm'", type: 'spanMm' },
    { field: 'span', id: 'km', title: "display: 'km'", type: 'spanKm' },
    { field: 'span', id: 'sig', title: '3 sig figs', type: 'spanSig' },
  ];

  const rows = [/* runs, each with a span in metres */];

  function App() {
    return (
      <LatticeGrid
        rowKey="id"
        dataTypes={dataTypes}
        columns={columns}
        rows={rows}
        style={{ height: '460px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>